player = {}
function player.load()
	player.width = 25
	player.height = 25
	player.x = 320
	player.y = 240
	player.xvel = 0
	player.yvel = 0
	player.friction = 9.5
	player.speed = 2250
	player.nshot = 0
	playerImg = love.graphics.newImage("player.png")
end

function player.draw()
	love.graphics.setColor(255,255,255)
	--love.graphics.circle('fill', player.x, player.y, player.height, 100)
	--love.graphics.circle('line', player.x, player.y, player.height, 100)
	love.graphics.draw(playerImg, player.x - 25, player.y - 25)
end	

function player.physics(dt)
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	player.xvel = player.xvel * (1 - math.min(dt*player.friction, 1)) 
	player.yvel = player.yvel * (1 - math.min(dt*player.friction, 1)) 
end

function player.boundary()
	if player.x < player.width then
		player.x = player.width
		player.xvel = 0
	end
	if player.y < player.height then
		player.y = player.height
		player.yvel = 0
	end
	if player.x + player.width > screenWidth then
		player.x = screenWidth - player.width
		player.xvel = 0
	end
	if player.y + player.height > screenHeight then
		player.y = screenHeight - player.height
		player.yvel = 0
	end	
end	

function player.move(dt)
	if love.keyboard.isDown('d') and player.xvel < player.speed then
		player.xvel = player.xvel + player.speed * dt
	end

	if love.keyboard.isDown('a') and player.xvel > -player.speed then
		player.xvel = player.xvel - player.speed * dt
	end

	if love.keyboard.isDown('w') and player.yvel > -player.speed then
		player.yvel = player.yvel - player.speed * dt
	end

	if love.keyboard.isDown('s') and player.yvel < player.speed then
		player.yvel = player.yvel + player.speed * dt
	end
end	

function player.shoot(key)

	if key == 'up' then
		bullet.spawn(player.x - bullet.width/2, player.y - player.height - bullet.height, 'up')
		TEsound.play("shoot.mp3")
		player.nshot = player.nshot + 1
	end
	
	if key == 'down' then
		bullet.spawn(player.x - bullet.width/2, player.y + player.height + bullet.height, 'down')
		TEsound.play("shoot.mp3")
		player.nshot = player.nshot + 1
	end

	if key == 'right' then
		bullet.spawn(player.x + player.width + bullet.width, player.y - bullet.width/2, 'right')
		TEsound.play("shoot.mp3")
		player.nshot = player.nshot + 1
	end

	if key == 'left' then
		bullet.spawn(player.x - player.width - bullet.width, player.y - bullet.width/2, 'left')
		TEsound.play("shoot.mp3")
		player.nshot = player.nshot + 1
	end
end


-- PARENT FUNCTIONS --
function DRAW_PLAYER()
	player.draw()
end

function UPDATE_PLAYER(dt)
	player.physics(dt)
	player.boundary()
	player.move(dt)
end